unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ExtCtrls;

type
  TMainForm = class(TForm)
    MainPanel: TPanel;
    TopPanel: TPanel;
    BottomPanel: TPanel;
    ReadEdit: TEdit;
    WriteEdit: TEdit;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    PanelLeftRatio : real;
    PanelTopRatio : real;
    PanelHeightRatio, PanelWidthRatio : real;
    BottomPanelHeightRatio : real;
    OriginalWidth, OriginalHeight : integer;
    Keyboard : array[1..30] of TButton;

  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;
  Charkeys : array[1..30] of String = (
             'Q', 'W', 'E', 'R', 'T', 'Y', 'U', 'I', 'O', 'P',
             'A', 'S', 'D', 'F', 'G', 'H', 'J', 'K', 'L', ';',
             'Z', 'X', 'C', 'V', 'B', 'N', 'M', ',', '.', '-'
    );

implementation

{$R *.DFM}

procedure TMainForm.FormCreate(Sender: TObject);
  procedure SetConstants;
  begin
   PanelLeftRatio  := Width/TopPanel.Left;
   PanelTopRatio := Height/TopPanel.Top;
   PanelWidthRatio := Width/TopPanel.Width;
   PanelHeightRatio := Height/TopPanel.Height;
   BottomPanelHeightRatio := BottomPanel.Top/Height;
   OriginalWidth := Width;
   OriginalHeight := Height;


  end;

  procedure CreateButtons;
  var ButtonsLeftMargin : array[1..3] of integer;
       ButtonsTopMargin : integer;
      ButtonsWidth, ButtonsHeight : integer;
      i,j,TopEnum,LeftEnum :integer;
  begin
    ButtonsLeftMargin[1] := Round(BottomPanel.Width/20);
    ButtonsTopMargin := Round(BottomPanel.Height/20);
    ButtonsWidth := Round((BottomPanel.Width-2*ButtonsLeftMargin[1])/11);
    ButtonsHeight := Round((BottomPanel.Height-2*ButtonsTopMargin)/3);

    ButtonsLeftMargin[2] := ButtonsLeftMargin[1]+Round(ButtonsWidth/2);
    ButtonsLeftMargin[3] := ButtonsLeftMargin[2]+Round(ButtonsWidth/2);

    for i := 1 to 30 do begin
        Keyboard[i] := TButton.Create(self);
        with Keyboard[i] do begin
             Width := ButtonsWidth;
             Height := ButtonsHeight;
             Parent := BottomPanel;
             Left := ButtonsLeftMargin[((i-1) div 10)+1] + ButtonsWidth*((i-1) mod 10);
             Caption := CharKeys[i];
             Visible := True;
             Top := ButtonsTopMargin + ((i-1) div 10)*ButtonsHeight;
             Font.Size := ButtonsHeight div 2;
             Font.Style := [fsBold];
        end;
    end;
  end;






begin
     SetConstants;
     CreateButtons;
end;

procedure TMainForm.FormResize(Sender: TObject);
begin

       TopPanel.ScaleBy(round(sqrt(Width*Height)),round(sqrt(OriginalWidth*OriginalHeight)));
       BottomPanel.ScaleBy(round(sqrt(Width*Height)),round(sqrt(OriginalWidth*OriginalHeight)));
       BottomPanel.Top := Round(BottomPanelHeightRatio*Height);
       OriginalWidth := Width;
       OriginalHeight := Height;
       ReadEdit.Font.Size := TopPanel.Height div 8;
       WriteEdit.Font.Size := TopPanel.Height div 8;

end;

end.
